#ifndef VEHAVE_CONTROL_H
#define VEHAVE_CONTROL_H

#define VEHAVE_CSR_DEBUG_NUM "3106"
#define VEHAVE_CSR_DEBUG(reg)                                                  \
  do {                                                                         \
    __asm__ __volatile__("csrr " #reg ", " VEHAVE_CSR_DEBUG_NUM : : :);        \
  } while (0)

#define vehave_disable_debug() VEHAVE_CSR_DEBUG(x0)
#define vehave_enable_debug() VEHAVE_CSR_DEBUG(x1)

#define vehave_disable_tracing() VEHAVE_CSR_DEBUG(x2)
#define vehave_enable_tracing() VEHAVE_CSR_DEBUG(x3)

#define vehave_start_mark() VEHAVE_CSR_DEBUG(x4)
#define vehave_stop_mark() VEHAVE_CSR_DEBUG(x5)

#define vehave_commit_trace() VEHAVE_CSR_DEBUG(x6)

#define VEHAVE_CSR_TRACE_TYPE_NUM "3107"
#define vehave_trace_set_type(value)                                           \
  do {                                                                         \
    __asm__ __volatile__("csrw " VEHAVE_CSR_TRACE_TYPE_NUM ", %0"              \
                         :                                                     \
                         : "r"(value));                                        \
  } while (0)

#define VEHAVE_CSR_TRACE_VALUE_NUM "3108"
#define vehave_trace_set_value(value)                                          \
  do {                                                                         \
    __asm__ __volatile__("csrw " VEHAVE_CSR_TRACE_VALUE_NUM ", %0"             \
                         :                                                     \
                         : "r"(value));                                        \
  } while (0)

#define vehave_trace(type, value)                                              \
  do {                                                                         \
    vehave_trace_set_type(type);                                               \
    vehave_trace_set_value(value);                                             \
    vehave_commit_trace();                                                     \
  } while (0);

#endif
